<template>
  <div class="container">
    <div class="row">
      <div class="form-group col-md-4">
        <label class="control-label">
          Socios Comerciales
        </label>
        <p-radio class="d-inline-block" v-model="es_representacion" label="1">Si</p-radio>
        <p-radio class="d-inline-block" v-model="es_representacion" label="0">No</p-radio>
      </div>
    </div>
    <div v-if="es_representacion == '1'">
      <div v-if="add_item">
        <div class="row">
          <legend>Socios Comerciales </legend>
        </div>
        <div class="row">
          <div class="form-group col-md-12">
            <label class="control-label">
              Nombre de la actividad comercial vinculante:
            </label>
            <input class="form-control" type="text" name="nombre_actividad" v-validate="sociosValidations.nombre_actividad" v-model="item_socios.nombre_actividad" placeholder="Nombre de la actividad comercial" /><small class="text-danger" v-show="nombre_actividad.invalid">
              {{ getError('nombre_actividad') }}
            </small>
          </div>
        </div>
        <div class="row">
          <div class="form-group col-md-4">
            <label class="control-label">
              Tipo de Vinculo
            </label>
            <input class="form-control" type="text" name="tipo_vinculo" v-validate="sociosValidations.tipo_vinculo" v-model="item_socios.tipo_vinculo" placeholder="Tipo de vinculo" /><small class="text-danger" v-show="tipo_vinculo.invalid">
              {{ getError('tipo_vinculo') }}
            </small>
          </div>
          <div class="form-group col-md-4">
            <label class="control-label">
              Antigüedad del vínculo
            </label>
            <input class="form-control" type="text" name="antiguedad_vinculo" v-validate="sociosValidations.antiguedad_vinculo" v-model="item_socios.antiguedad_vinculo" placeholder="Antigüedad de vinculo" /><small class="text-danger" v-show="antiguedad_vinculo.invalid">
              {{ getError('antiguedad_vinculo') }}
            </small>
          </div>
          <div class="form-group col-md-4">
            <label class="control-label">
              RFC de la entidad vinculante (si aplica)
            </label>
            <input class="form-control" type="text" name="rfc_entidad" v-validate="sociosValidations.rfc_entidad" v-model="item_socios.rfc_entidad" placeholder="RFC" /><small class="text-danger" v-show="rfc_entidad.invalid">
              {{ getError('rfc_entidad') }}
            </small>
            <small class="text-danger" v-show="validaciones.rfc_entidad">
              El formato del RFC no es válido, verifica la información
            </small>
          </div>
        </div>
        <div class="row">
          <legend> Datos del Socio</legend>
          <div class="form-group col-md-6">
            <label class="control-label">
              Nombre, denominación o razón social del socio comercial:
            </label>
            <input class="form-control" type="text" name="nombre" v-validate="sociosValidations.nombre" v-model="item_socios.nombre" placeholder="Nombre del socio comercial" /><small class="text-danger" v-show="nombre.invalid">
              {{ getError('nombre') }}
            </small>
          </div>
          <div class="form-group col-md-6">
            <label class="control-label">
              CURP del socio (si aplica)
            </label>
            <input class="form-control" type="text" name="curp" v-validate="sociosValidations.curp" v-model="item_socios.curp" placeholder="CURP" /><small class="text-danger" v-show="curp.invalid">
              {{ getError('curp') }}
            </small>
            <small class="text-danger" v-show="validaciones.curp">
              El formato de la CURP no es válido, verifica la información
            </small>
          </div>
          <div class="form-group col-md-6">
            <label class="control-label">
              RFC del socio (si aplica)
            </label>
            <input class="form-control" type="text" name="rfc" v-validate="sociosValidations.rfc" v-model="item_socios.rfc" placeholder="RFC del Socio" /><small class="text-danger" v-show="rfc.invalid">
              {{ getError('rfc') }}
            </small>
            <small class="text-danger" v-show="validaciones.rfc">
              El formato del RFC no es válido, verifica la información
            </small>
          </div>
        </div>
        <div class="row">
        </div>
        <div class="row">
          <div class="col-md-4">
            <div class="form-group">
              <label class="control-label">
                Lugar de nacimiento del socio
              </label>
              <p-radio name="lugar_nacimiento" v-validate="sociosValidations.lugar_nacimiento" v-model="item_socios.lugar_nacimiento" label="1">México</p-radio>
              <p-radio name="lugar_nacimiento" v-validate="sociosValidations.lugar_nacimiento" v-model="item_socios.lugar_nacimiento" label="2">Extranjero</p-radio>
            </div>
            <small class="text-danger" v-show="lugar_nacimiento.invalid">
              {{ getError('lugar_nacimiento') }}
            </small>
          </div>
          <div class="col-md-4" v-if="item_socios.lugar_nacimiento == 1">
            <label class="control-label">
              Entidad Federativa:
            </label>
            <el-select  clearable class="select-default" placeholder="Seleccione una entidad" filterable name="entidad_federativa_id" v-validate="sociosValidations.entidad_federativa_id" v-model="item_socios.entidad_federativa_id">
              <el-option v-for="option in entidades" class="select-default" :value="option.id" :label="option.nom_ent" :key="option.nom_ent">
              </el-option>
            </el-select> <small class="text-danger" v-show="entidad_federativa_id.invalid">
              {{ getError('entidad_federativa_id') }}
            </small>
          </div>
          <div class="col-md-4" v-if="item_socios.lugar_nacimiento == 2">
            <label class="control-label">
              País:
            </label>
            <el-select  clearable class="select-default" placeholder="Seleccione un país" filterable name="pais_id" v-validate="sociosValidations.pais_id" v-model="item_socios.pais_id">
              <el-option v-for="option in paisesnac" class="select-default" :value="option.id" :label="option.valor" :key="option.valor">
              </el-option>
            </el-select><small class="text-danger" v-show="pais_id.invalid">
              {{ getError('pais_id') }}
            </small>
          </div>
          <div class="col-md-4">
            <div class="form-group">
              <label class="control-label">
                Fecha de nacimiento del socio
              </label>
              <el-date-picker name="fecha_nacimiento" v-validate="sociosValidations.fecha_nacimiento" v-model="item_socios.fecha_nacimiento" type="date" placeholder="Seleccione fecha" value-format="dd-MM-yyyy" format="dd-MM-yyyy"></el-date-picker><small class="text-danger" v-show="fecha_nacimiento.invalid">
                {{ getError('fecha_nacimiento') }}
              </small>
            </div>
          </div>
        </div>
        <div class="row">
          <legend> Participación </legend>
          <div class=" col-md-6">
            <label class="control-label">
              Porcentaje de participacion ( % )
            </label>
            <input class="form-control" type="text" name="porcentaje_participacion" v-validate="sociosValidations.porcentaje_participacion" v-model="item_socios.porcentaje_participacion" placeholder="Porcentaje de Participación" /><small class="text-danger" v-show="porcentaje_participacion.invalid">
              {{ getError('porcentaje_participacion') }}
            </small>
          </div>
          <div class="col-md-6">
            <label class="control-label">
              Sector/Industria:
            </label>
            <el-select  clearable class="select-default" placeholder="Seleccione un sector-industria" filterable name="sector_industria_id" v-validate="sociosValidations.sector_industria_id" v-model="item_socios.sector_industria_id">
              <el-option v-for="option in sectores" class="select-default" :value="option.id" :label="option.valor" :key="option.label"></el-option>
            </el-select><small class="text-danger" v-show="sector_industria_id.invalid">
              {{ getError('sector_industria_id') }}
            </small>
          </div>
          <div class="form-group col-md-6" v-if=" item_socios.sector_industria_id == 11">
            <label class="control-label">Especificar sector industria</label>
            <input class="form-control" type="text" name="especificar_sector_industria" v-validate="sociosValidations.especificar_sector_industria" v-model="item_socios.especificar_sector_industria" placeholder="Especificar"><small class="text-danger" v-show="especificar_sector_industria.invalid">
              {{ getError('especificar_sector_industria') }}
            </small>
          </div>
          <div class=" col-md-12">
            <label class="control-label">
              Observaciones/Comentarios:
            </label>
            <input class="form-control" type="text" name="observaciones" v-model="item_socios.observaciones" placeholder="Observaciones/Comentarios" />
          </div>
        </div>
        <div class="row justify-content-end m-3">
          <button class="btn btn-primary" @click.prevent="addItem()">
            <span v-if="edit_item == null">
              <i class="fa fa-plus"></i> Agregar
            </span>
            <span v-else>
              <i class="fa fa-save"></i> Guardar
            </span>
          </button>
          <button class="btn btn-danger ml-3" @click.prevent="cancelEdit()">
            <span>
              <i class="fa fa-times"></i> Cancelar
            </span>
          </button>
        </div>
        <div class="row">
          <hr class="col-md-12 bg-info">
        </div>
      </div>
      <div v-if="!add_item">
        <div class="row justify-content-end m-3">
          <button class="btn btn-primary" @click.prevent="showItem()">
            <span>
              <i class="fa fa-plus"></i> Agregar
            </span>
          </button>
        </div>
        <div class="row mt-3 mb-4">
          <div class="col-sm-12 col-md-12 col-lg-12">
            <b-table id="tbl_socios" responsive hover :items="list_socios" :fields="fields_list" show-empty>
              <!-- :fields="fields_list" -->
              <template slot="acciones" slot-scope="row" class="actions">
                <b-button size="sm" @click.prevent="editItem(row)" class="edit mr-2" :disabled="edit_item != null">
                  Editar <i class="fas fa-pencil-alt ml-2"></i>
                </b-button>
                <b-button size="sm" @click.prevent="removeItem(row.index)" class="delete mr-2" :disabled="edit_item != null">
                  Eliminar <i class="fas fa-trash-alt ml-2"></i>
                </b-button>
              </template>
              <template slot="empty">
                <h5>No existen registros</h5>
              </template>
              <template slot="entidad_federativa_id" slot-scope="row">
                {{getEntidades(row.item.entidad_federativa_id)}}</template>
              <template slot="pais_id" slot-scope="row">{{getNacionalidades(row.item.pais_id)}}</template>
              <template slot="sector_industria_id" slot-scope="row">{{getSectores(row.item.sector_industria_id)}}</template>
            </b-table>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
  import {
    Tag,
    Select,
    DatePicker
  } from "element-ui";
  import Domicilio from "../Domicilio.vue";
  import {
    mapFields
  } from "vee-validate";
  export default {
    components: {
      [Tag.name]: Tag,
      [DatePicker.name]: DatePicker,
      Domicilio
    },
    computed: {
      ...mapFields([
        "nombre_actividad",
        "tipo_vinculo",
        "antiguedad_vinculo",
        "rfc_entidad",
        "nombre",
        "curp",
        "rfc",
        "lugar_nacimiento",
        "entidad_federativa_id",
        "pais_id",
        "fecha_nacimiento",
        "porcentaje_participacion",
        "sector_industria_id",
        "especificar_sector_industria"
      ])
    },
    watch: {
      list_socios: {
        handler: function () {
          if (this.list_socios) {
            if (this.list_socios.length == 0) {
              this.es_representacion = "0";
            } else {
              this.es_representacion = "1";
            }
          }
        },
        deep: true
      }
    },
    data() {
      return {
        validaciones: {
          rfc_entidad: false
        },
        ip_id: 1,
        add_item: false,
        edit_item: null,
        es_representacion: "0",
        paisesnac: null,
        sectores: null,
        entidades: null,
        item_socios: {},
        list_socios: [],
        sociosValidations: {
          nombre_actividad: {
            required: true
          },
          tipo_vinculo: {
            required: true
          },
          antiguedad_vinculo: {
            required: true
          },
          rfc_entidad: {
            max: 13
          },
          nombre: {
            required: true
          },
          curp: {
            max: 18
          },
          rfc: {
            max: 13
          },
          lugar_nacimiento: {
            required: true
          },
          entidad_federativa_id: {
            required: true
          },
          pais_id: {
            required: true
          },
          fecha_nacimiento: {
            required: true
          },
          porcentaje_participacion: {
            required: true
          },

          sector_industria_id: {
            required: true
          },

          especificar_sector_industria: {
            required: true
          }
        },
        fields_list: [{
            key: "acciones",
            label: "Acciones",
            tdClass: "text-center"
          },
          {
            key: "nombre_actividad",
            label: "Nombre actividad",
            tdClass: "text-left",
            formatter: "emptyFields"
          },
          {
            key: "tipo_vinculo",
            label: "Tipo de Vinculo",
            tdClass: "text-left",
            formatter: "emptyFields"
          },
          {
            key: "antiguedad_vinculo",
            label: "Antigüedad del vinculo",
            tdClass: "text-left",
            formatter: "emptyFields"
          },
          {
            key: "rfc_entidad",
            label: "RFC de la entidad vinculante",
            tdClass: "text-left",
            formatter: "emptyFields"
          },
          {
            key: "nombre",
            label: "Nombre del socio",
            tdClass: "text-left",
            formatter: "emptyFields"
          },
          {
            key: "curp",
            label: "CURP del socio",
            tdClass: "text-right",
            formatter: "emptyFields"
          },
          {
            key: "rfc",
            label: "RFC del socio",
            tdClass: "text-right",
            formatter: "emptyFields"
          },
          {
            key: "pais_id",
            label: "Pais de nacimiento del socio",
            tdClass: "text-center",
            formatter: "emptyFields"
          },
          {
            key: "entidad_federativa_id",
            label: "Entidad Federativa del socio",
            tdClass: "text-right",
            formatter: "emptyFields"
          },
          {
            key: "fecha_nacimiento",
            label: "Fecha de Nacimiento Socio",
            tdClass: "text-right",
            formatter: "emptyFields"
          },
          {
            key: "porcentaje_participacion",
            label: "Porcentaje Socio",
            tdClass: "text-right",
            formatter: "emptyFields"
          },
          {
            key: "sector_industria_id",
            label: "Sector Industria",
            tdClass: "text-center",
            formatter: "emptyFields"
          },
          {
            key: "observaciones",
            label: "Observaciones",
            tdClass: "text-left",
            formatter: "emptyFields"
          }
        ],
        pickerOptions1: {
          shortcuts: [{
              text: "Today",
              onClick(picker) {
                picker.$emit("pick", new Date());
              }
            },
            {
              text: "Yesterday",
              onClick(picker) {
                const date = new Date();
                date.setTime(date.getTime() - 3600 * 1000 * 24);
                picker.$emit("pick", date);
              }
            },
            {
              text: "A week ago",
              onClick(picker) {
                const date = new Date();
                date.setTime(date.getTime() - 3600 * 1000 * 24 * 7);
                picker.$emit("pick", date);
              }
            }
          ]
        },
        datePicker: "",
        model: {
          nombre: "",
          aPaterno: "",
          aMaterno: "",
          curp: "",
          tparticular: "",
          tcelular: "",
          rfc: "",
          nidentifica: "",
          cpersonal: "",
          pResidencia: "1",
          nacionalidades: {},
          email: "",
          estudios: "1"
        },

        tags: {
          dynamicTags: ["Mexicana"],
          inputVisible: false,
          inputValue: ""
        },
        modelValidations: {
          nombre: {
            min: 5
          },
          aPaterno: {
            min: 5
          },
          aMaterno: {
            min: 5
          },
          email: {
            required: true,
            email: true
          }
        }
      };
    },
    methods: {
      getNacionalidades(index) {
        var resp = " ";
        if (this.paisesnac) {
          this.paisesnac.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getEntidades() {
        this.$http.get("entidadFed").then(
          response => {
            this.entidades = response.data.entidadfed;
          },
          error => {
            this.StepError(error);
            //console.log(error);
          }
        );
      },
      getSectores(index) {
        var resp = " ";
        if (this.sectores) {
          this.sectores.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      initItem() {
        this.n_domicilio = {
          pais: 150,
          entidadF: "",
          municipio: "",
          localidad: "",
          cp: "",
          colonia: "",
          vialidad: "",
          vialidad_nombre: "",
          ext: "",
          int: ""
        };
        this.item_bienes = {
          acciones: "",
          tipo_operacion_id: "",
          tipo_bien_id: "",
          titular_id: "",
          superficie_construccion: "",
          superficie_terreno: "",
          porcentaje_propiedad: 100,
          identificacion_bien_numero_escritura_publica: "",
          identificacion_bien_numero_registro_publico: "",
          identificacion_bien_folio_real: "",
          identificacion_bien_fecha_contrato: "",
          nombre_copropietario_nombres: "",
          nombre_copropietario_primer_apellido: "",
          nombre_copropietario_segundo_apellido: "",
          precio_adquisicion_valor: "",
          precio_adquisicion_moneda_id: 97,
          valor_catastral: "",
          fecha_adquisicion: "",
          forma_adquisicion_id: "",
          domicilio_bien_pais_id: "",
          domicilio_bien_entidad_federativa_id: "",
          domicilio_bien_municipio_id: "",
          domicilio_bien_localidad_id: "",
          domicilio_bien_colonia: "",
          domicilio_bien_cp: "",
          domicilio_bien_numext: "",
          domicilio_bien_numint: "",
          domicilio_bien_vialidad_nombre: "",
          domicilio_bien_vialidad_tipo: "",
          nombre_denominacion_quien_adquirio: "",
          rfc_quien_adquirio: "",
          curp_quien_adquirio: "",
          sector_industria_id: "",
          relacion_persona_adquirio_id: "",
          relacion_especificar: "",
          observaciones: ""
        };
      },
      showItem() {
        this.add_item = !this.add_item;
      },
      cancelEdit() {
        if (this.edit_item) {
          this.edit_item.item._rowVariant = "";
        }
        //this.initItem();
        this.showItem();
        this.edit_item = null;
      },
      addItem() {
        this.$validator.validateAll().then(response => {
          if (response) {
            if (this.item_socios) {
              this.item_socios.ip_id = this.ip_id;
              this.loadButton(this.$refs.btnSave);
              this.$http.post("socios_comerciales", this.item_socios).then(
                response => {
                  this.StepOk("Guardado");
                  if (this.edit_item === undefined || this.edit_item === null) {
                    this.list_socios.push({
                      ...response.data.socio
                    });
                  } else {
                    this.list_socios.splice(
                      this.edit_item.index,
                      1,
                      this.item_socios
                    );
                    this.edit_item.item._rowVariant = "";
                  }
                  this.showItem();
                  this.initItem();
                  this.edit_item = null;
                },
                error => {
                  this.StepError(error);
                  //this.change =  true;
                }
              );
            }
          } else {
            this.StepW("Hay campos sin completar");
          }
        });
        //console.log(this.item_bienes);
      },
      editItem(indice) {
        this.showItem();
        this.edit_item = indice;
        this.item_socios = {
          ...this.list_socios[this.edit_item.index]
        };
        //this.editDomicilio();
        this.edit_item.item._rowVariant = "danger";
        $(".main-panel").animate({
            scrollTop: 100
          },
          500,
          "swing"
        );
      },
      removeItem(indice) {
        if (this.list_socios[indice].id !== null) {
          let item = this.list_socios[indice];
          this.list_socios.splice(indice, 1);
          this.Ask("Desea borrar este registro", () => {
            this.$http.delete("socios_comerciales/" + item.id).then(
              response => {
                /* eventBus.$emit("TramiteDelete", item); */
                this.list_socios.splice(indice, 1);
              },
              error => {
                this.Err(error);
              }
            );
          });
        } else {
          this.Ask("Desea borrar este registro", () => {
            this.list_socios.splice(indice, 1);
          });
        }
      },
      getError(fieldName) {
        return this.errors.first(fieldName);
      },
      validate() {
        if (this.add_item) {
          this.validaciones = {
            curp: false,
            rfc_entidad: false
          };
          if (!this.curp(this.item_socios.curp)) {
            this.validaciones.curp = true;
            return false;
          }
          if (!this.rfcValido(this.item_socios.rfc_entidad)) {
            this.validaciones.rfc_entidad = true;
            return false;
          }
          if (!this.rfcValido(this.item_socios.rfc)) {
            this.validaciones.rfc = true;
            return false;
          }
        }

        return this.$validator.validateAll();
      },
      handleClose(tag) {
        this.tags.dynamicTags.splice(this.tags.dynamicTags.indexOf(tag), 1);
      },
      showInput() {
        this.tags.inputVisible = true;
        this.$nextTick(() => {
          this.$refs.saveTagInput.$refs.input.focus();
        });
      },
      handleInputConfirm() {
        let inputValue = this.tags.inputValue;
        if (inputValue) {
          this.tags.dynamicTags.push(inputValue);
        }
        this.tags.inputVisible = false;
        this.tags.inputValue = "";
      }
    },
    created() {
      var v = this;
      v.getEntidades();
      this.initItem();
      this.$http.get("socios_comerciales/" + this.ip_id).then(
        response => {
          this.list_socios = response.data.socios;
          //this.setLocalidades();
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("paises").then(
        response => {
          this.paisesnac = response.data.pais;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("cat_sector_industria").then(
        response => {
          this.sectores = response.data.sectores;
        },
        error => {
          this.Err(error);
        }
      );
    }
  };

</script>
<style>


</style>
